Unit sn_Obj;
Interface
Uses
     Dos;

Type
     pcDirRec=
      record
       fname:string[8];
       fext:string[3];
       flength:longint;
       mark:boolean;
       fdt:datetime;
       fattr:word;
       priory:byte;
       description:string[1];
      end;
     pcDirP=array[1..1]of pcDirRec;

     pcInsedRec=
      record
       crc16:word;
      end;
     pcInsedP=array[1..1] of pcInsedRec;

Type
     PPanel=^TPanel;
     TPanel=
      object
       Place                    :byte;
       PanelLong, PanelHi,
       Columns                  :byte;
       InfoLines                :byte;
       PutFrom, PosX, PosY      :byte;
       NameLine                 :boolean;
       Visible                  :boolean;
       Focused                  :boolean;

       PanelType                :byte;
       clLastPanelType,
       ckLastPanelType,
       LastPanelType            :byte;

       xc,yc,lc                 :byte;
       tdirs,tfiles             :integer;
       from,f                   :integer;

       pcDir                    :^pcdirp;
       pcIns                    :^pcinsedp;
       pcnd,oldpcnd             :string;
       pcnn                     :string;
       TreeC                    :byte;
       SortType                 :byte;

       pctdirs,pctfiles         :integer;
       oldpctdirs,oldpctfiles   :integer;

       pcf,pcfrom               :integer;

       Procedure PanelSetup;
       Procedure Build(parts:string);
       Procedure Hide;
       {
       Procedure ShowCur;
       Procedure HideCur;
       {}
       procedure pcAdd(r:pcdirrec; isitdir:boolean; ind:integer);
       procedure pcMDF(path:pathstr);
       procedure GetCurXY(var x,y:byte);
       procedure pcPDF(fr:integer);

       procedure MDF;
       procedure PDF;

       Procedure Info(parts:string);

       Function  GetTreeC(path:string):byte;
       Function  Insed:word;

       Procedure Inside;
       Procedure Outside;
       Function  Index:word;
       Function  TrueName(ind:word):string;
       Procedure TrueCur;

       Procedure Enter;
       Procedure CtrlPgUp;
       Procedure CtrlPgDn;

       Procedure AltF1F2(ps:byte);
       Procedure CtrlLeft;
       Procedure CtrlRight;
       Procedure CtrlLeftRightDoIt(stemp:char);

       Procedure Insert;
       Procedure Star(Ctrled:boolean);
       Procedure Plus(Ctrled:boolean);
       Procedure Minus(Ctrled:boolean);

       Function  FirstMarked:word;
       Procedure Del;

       Procedure fCopy;
       Procedure fMove;
       Procedure Rename;
       Function  View(sys:boolean):longint;
       Procedure Edit;
       Procedure FileAttrs;
       Procedure AltNumber(n:byte);

       Procedure pcJoinFiles;
       Procedure Navigate;
      end;

Var
     rp,lp:TPanel;

Implementation
Uses
     Crt, RV, Mouse, Clock,
     Vars, Palette, sn_Mem, Main, Main_Ovr, Sorting, Utils,
     PC,PC_Ovr;



{============================================================================}
Procedure TPanel.PanelSetup;
Var
    i:byte;
Begin
PanelLong:=gmaxy-1;
if CmdLine then dec(PanelLong);

PanelHi:=gmaxy-4-InfoLines;
if NameLine then Begin dec(PanelHi); PutFrom:=3; End else PutFrom:=2;
if CmdLine then dec(PanelHi);
End;




{============================================================================}
Procedure TPanel.Build(parts:string);
Var
    s:string;
Begin
PanelSetup;{}
if Columns<1 then Columns:=1;
if Columns>3 then Columns:=3;

if pos('0',parts)<>0 then if PanelType<>noPanel then
 begin
  s:='ͻ';
  if (posx<>1)and clocked then s:='';
  cmprint(BkRama,TxtRama,posx,1, s);
  for i:=1 to PanelLong-2 do cmprint(BkRama,TxtRama,posx,1+i, '                                      ');
  cmprint(BkRama,TxtRama,posx,PanelLong, 'ͼ');
 end;

if pos('1',parts)<>0 then if (PanelType>=1)and(PanelType<=10) then
 begin
  for i:=1 to PanelLong-InfoLines-3 do
   begin
    case Columns of
     1:  begin
          cmprint(BkRama,TxtRama,posx+13,1+i,'');
          cmprint(BkRama,TxtRama,posx+26,1+i,' ');{}
          cmprint(BkRama,TxtRama,posx+19,1+i,' ');{}
         end;
     2:  begin
          {cmprint(BkRama,TxtRama,posx+13,1+i,' ');{}
          {cmprint(BkRama,TxtRama,posx+26,1+i,' ');{}
          cmprint(BkRama,TxtRama,posx+19,1+i,'');
         end;
     3:  begin
          cmprint(BkRama,TxtRama,posx+13,1+i,'');
          cmprint(BkRama,TxtRama,posx+26,1+i,'');
          {cmprint(BkRama,TxtRama,posx+19,1+i,' ');{}
         end;
    end;
   end;

  case Columns of
   1:  s:='ĺ';
   2:  s:='ĺ';
   3:  s:='ĺ';
  end;
  cmprint(BkRama,TxtRama,posx,PanelLong-InfoLines-1,s);
 end;

if pos('2',parts)<>0 then if (PanelType>=1)and(PanelType<=10) then
 begin
  if NameLine then
   begin
    if lang=rus then s:='         ' else s:='    Name    ';
    case Columns of
     1:
        Begin
         cmprint(BkNameLine,TxtNameLine,posx+1,2,s);
         if lang=rus then s:='ᠭ' else s:='Description';
         cmprint(BkNameLine,TxtNameLine,posx+15,2,s+space(24-length(s)));
        End;
     2:
        Begin
         cmprint(BkNameLine,TxtNameLine,posx+4,2,s+space(3));
         cmprint(BkNameLine,TxtNameLine,posx+20,2,space(4)+s);
        End;
     3:
        Begin
         cmprint(BkNameLine,TxtNameLine,posx+1,2,s);
         cmprint(BkNameLine,TxtNameLine,posx+1+13,2,s);
         cmprint(BkNameLine,TxtNameLine,posx+1+13+13,2,s);
        End;
    end;
   end;
 end;

End;




{============================================================================}
procedure TPanel.Hide;
var
   dy,ix,iy,i:word; dx:byte;
begin
 if CmdLine then dy:=gmaxy-3 else dy:=gmaxy-2;
 i:=posx*2-1;
 for iy:=0 to dy{gmaxy-3{} do
  begin
   if Clocked and (iy=0)and(posx=41) then dx:=30 else dx:=40;
   for ix:=posx-1 to posx+dx-2 do
    begin
     mem[$B800:((80*iy)+ix)*2]:=SavedDeskTop^[i];   inc(i);
     mem[$B800:((80*iy)+ix)*2+1]:=SavedDeskTop^[i]; inc(i);
    end;
   if dx=40 then inc(i,80) else inc(i,100);
  end;
 PanelType:=noPanel;
end;


{============================================================================}
{
Procedure TPanel.ShowCur;
Var
    i:byte;
    px,py,paper,ink,dx,dlc:byte;
Begin
yc:=PutFrom-1; xc:=posx+1;
if Columns=2 then begin dx:=19; lc:=18; end else begin dx:=13; lc:=12; end;
if Columns=1 then begin dx:=0; lc:=38; end;
paper:=bkCurNT; ink:=txtCurNT;
for i:=1 to f do
 begin
  inc(yc);
  if yc>PanelHi+PutFrom-1 then begin inc(xc,dx); yc:=PutFrom; end;
  if xc=posx+20 then dlc:=1 else dlc:=0;
 end;
printself(paper,ink,xc,yc,lc+dlc);
End;
{}

{============================================================================}
{
Procedure TPanel.HideCur;
Var
    i:byte;
    px,py,paper,ink,dx,dlc:byte;
Begin
if Columns=2 then begin dx:=19; lc:=18; end else begin dx:=13; lc:=12; end;
if Columns=1 then begin dx:=0; lc:=38; end;
paper:=bkNT; ink:=txtNT;
printself(paper,ink,xc,yc,lc+dlc);
End;
{}


{============================================================================}
procedure TPanel.pcAdd(r:pcdirrec; isitdir:boolean; ind:integer);
var
   m:integer;
begin
pcdir^[ind].fname  :=r.fname;
pcdir^[ind].fext   :=r.fext;
pcdir^[ind].fdt    :=r.fdt;
pcdir^[ind].fattr  :=r.fattr;
pcdir^[ind].mark   :=false;
if isitdir then
 begin
  pcdir^[ind].flength:=-1; pcdir^[ind].priory:=0;
 end
else
 begin
  pcdir^[ind].flength:=r.flength;  pcdir^[ind].priory:=10;
  r.fext:=nospace(strlo(r.fext)); if r.fext='' then r.fext:='.';
  if pos(';'+r.fext+';',pr1)<>0 then pcdir^[ind].priory:=1;
  if pos(';'+r.fext+';',pr2)<>0 then pcdir^[ind].priory:=2;
  if pos(';'+r.fext+';',pr3)<>0 then pcdir^[ind].priory:=3;
  if pos(';'+r.fext+';',pr4)<>0 then pcdir^[ind].priory:=4;
  if pos(';'+r.fext+';',pr5)<>0 then pcdir^[ind].priory:=5;
  if pos(';'+r.fext+';',pr6)<>0 then pcdir^[ind].priory:=6;
  if pos(';'+r.fext+';',pr7)<>0 then pcdir^[ind].priory:=7;
  if pos(';'+r.fext+';',pr8)<>0 then pcdir^[ind].priory:=8;
  if pos(';'+r.fext+';',pr9)<>0 then pcdir^[ind].priory:=9;
 end;
end;



{============================================================================}
procedure TPanel.pcMDF(path:pathstr);
var
   rec:searchrec; dt:datetime;
   strtemp:string; fattrm,ie,i,m,j,readed:integer;
   fa:file; fnew:pcdirrec; nd:string; pcinsed:word;
Label beg;
begin
beg:
j:=0; nd:=pcnd;
for i:=1 to pctdirs+pctfiles do if pcdir^[i].mark then
 begin inc(j); pcins^[j].crc16:=crc16(pcdir^[i].fname+'.'+pcdir^[i].fext); end;
pcinsed:=j;

path:=checkpath(path);
if (path[length(path)]='\')and(length(path)>3) then delete(path,length(path),1);
{$I-} chdir(Path); {$I+}
if ioresult<>0 then Begin Path:='C:'; goto beg; end;

pcnd:=curentdir; if pcnd[length(pcnd)]<>'\' then pcnd:=pcnd+'\';
GetTreeC(pcnd);
oldpctdirs:=pctdirs; oldpctfiles:=pctfiles;
pctdirs:=0; pctfiles:=0;

findfirst('*.*',$3F,rec);
while doserror=0 do
 begin
  if (rec.name='.') then findnext(rec);
  unpacktime(rec.time,dt);
  fnew.fname:=getof(rec.name,_name);
  fnew.fext:=copy(getof(rec.name,_ext),2,3);
  if rec.name='..' then begin fnew.fname:=' ..'; fnew.fext:=''; end;
  fnew.fext:=fnew.fext+space(3-length(fnew.fext));
  fnew.flength:=rec.size;
  fnew.fdt:=dt;
  fnew.fattr:=rec.attr;
  fnew.mark:=false;

  if (rec.attr and directory = directory) then
  if HideHidden then
   begin
    if (rec.attr and hidden <> hidden) then
    begin inc(pctdirs); pcAdd(fnew,true,pctdirs+pctfiles); end;
   end
  else
   begin
    begin inc(pctdirs); pcAdd(fnew,true,pctdirs+pctfiles); end;
   end;

  if (rec.attr and (directory or volumeid)=0) then
  if HideHidden then
   begin
    if (rec.attr and hidden <> hidden) then
    begin inc(pctfiles); pcAdd(fnew,false,pctdirs+pctfiles); end;
   end
  else
   begin
    begin inc(pctfiles); pcAdd(fnew,false,pctdirs+pctfiles); end;
   end;

  if (rec.name='..')and(treec=1) then dec(pctdirs);{}
  if pctdirs<0 then pctdirs:=0;
  if pctfiles<0 then pctfiles:=0;

  if pctdirs+pctfiles>(MaxFiles-10) then
   begin
    if lang=rus then errormessage('誮  䠩')
                else errormessage('More than '+strr(MaxFiles)+' files');
    break;
   end;
  findnext(rec);
 end;

for i:=pctdirs+pctfiles+1 to pctdirs+pctfiles+panelhi*Columns do
 begin
  pcdir^[i].fname:='        ';
  pcdir^[i].fext:='   ';
 end;

globalsort(left);
globalsort(right);

if path[length(path)]<>'\' then path:=path+'\';
if path=nd then for i:=1 to pcinsed do for j:=1 to pctdirs+pctfiles do
if pcins^[i].crc16=crc16(pcdir^[j].fname+'.'+pcdir^[j].fext) then pcdir^[j].mark:=true;
End;








{============================================================================}
Procedure TPanel.GetCurXY(var x,y:byte);
Var
    px,py,dx:byte;
    i,n:integer;
Begin
n:=tdirs+tfiles;
if n>from-1+panelhi*Columns then n:=from-1+panelhi*Columns;
px:=posx+1; py:=putfrom;
Case Columns of 1: dx:=13; 2: dx:=19; 3: dx:=13; End;
for i:=from to n do
 begin
  if i=Index then
   begin
    x:=px; y:=py; Exit;
   end;
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,dx); end;
 end;
End;




{============================================================================}
procedure TPanel.pcPDF(fr:integer);
var px,py,py0,ph,paper,ink,pp,ii,iii,dx,ddx:byte;
    i,n:integer;
    s,name:string; e:string[3];
begin

if paneltype<>pcPanel then exit;{}

n:=pctdirs+pctfiles;
if n>fr-1+panelhi*Columns then n:=fr-1+panelhi*Columns;
px:=posx+1; py:=putfrom;
Case Columns of 1: dx:=13; 2: dx:=19; 3: dx:=13; End;
for i:=fr to n do
 begin
  if (px=21)or(px=61) then ddx:=1 else ddx:=0;
  name:=pcDir^[i].fname; if name[1]=' ' then delete(name,1,1);
  name:=name+space((dx+ddx-5)-length(name))+' '+pcDir^[i].fext;
  if i>pctdirs then name:=strlo(name);
  paper:=bkNT; ink:=txtNT;
  if i<=pctdirs then begin paper:=bkDir; ink:=txtDir; ii:=ink; end
  else
   begin
    e:=nospace(copy(name,(dx+ddx-3),3)); if e='' then e:='.';
    col(e,pcDir^[i].flength,paper,ink);
   end;
  pp:=paper; ii:=ink; iii:=ink;
  if pcdir^[i].mark then begin paper:=bkST; ink:=txtST; end;
  if focused and(i=from+f-1) then begin paper:=bkCurNT; ink:=txtCurNT; end;
  if focused and(i=from+f-1)and(pcdir^[i].mark) then begin paper:=bkCurST; ink:=txtCurST; end;
  if ((pcdir^[i].fattr and SysFile) <> 0) then name[1]:=upcase(name[1]);
  e:=' ';
  if ((pcdir^[i].fattr and ReadOnly)<> 0) then e:=#$B0;
  if ((pcdir^[i].fattr and Hidden)  <> 0) then e:=#$B1;
  if ((pcdir^[i].fattr and SysFile) <> 0) then e:=#$B2;
  if pcdir^[i].mark then e:=#251;
  name[(dx+ddx-4)]:=e[1];
  cmprint(paper,ink,px,py,name);

  s:=space(25);
  if Columns=1 then
   begin
    cmprint(paper,ink,px+13,py,s); cmprint(paper,TxtRama,px+12,py,'');
   end;

  if ii=paper then ii:=ink;
  if focused and(i=from+f-1) then ii:=txtCurNT;
  if focused and(i=from+f-1)and(pcdir^[i].mark) then
    begin ii:=iii; if ii=bkCurST then ii:=txtCurST; end;
  PrintSelf(paper,ii,px+(dx+ddx-5),py,1);

  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,dx); end;
 end;

for i:=n+1 to panelhi*Columns do
 begin
  if (px=21)or(px=61) then ddx:=1 else ddx:=0;
  name:=space(dx+ddx-1);
  cmprint(bkNT,txtNT,px,py,name);
  if Columns=1 then
   begin
    cmprint(bkNT,txtNT,px+13,py,space(25)); cmprint(bkRama,TxtRama,px+12,py,'');
   end;
  inc(py);
  if py>panelhi+putfrom-1 then begin py:=putfrom; inc(px,dx); end;
 end;

end;




{============================================================================}
Procedure TPanel.MDF;
Begin
 case PanelType of
  pcPanel: pcMDF(pcnd);
 end;
End;



{============================================================================}
Procedure TPanel.PDF;
Begin
 case PanelType of
  pcPanel: pcPDF(pcfrom);
 end;
End;



{============================================================================}
Procedure TPanel.Info(parts:string);
Var
    s:string[127]; r:string[40]; itemp,a,b,p,x,y,d:byte; m,n:word; i,k:integer;
    nm,stemp:string[50]; ml,byt,byt2:longint; rbyt:real;
Begin
                        {== 騩 ⠫ ==}
if (pos('c',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=12) then
 Begin
  Case PanelType of
   pcPanel: if TreeC=1 then s:=' '+pcnd+' ' else s:=' '+copy(pcnd,1,length(pcnd)-1)+' ';
   infPanel: if lang=rus then s:=' ଠ ' else s:=' Information ';
  End;
  if length(s)>29 then s:=copy(s,1,4)+'...'+copy(s,length(s)-22,23);
  if focused then begin p:=bkNDactive; i:=txtNDactive; end else begin p:=bkNDpassive; i:=txtNDpassive; end;
  x:=length(s)div 2; if length(s)>x*2 then inc(x); x:=posx+20-x;
  r:='';
  if posx<>left then if clocked then
   begin
    r:='';
    if x+length(s)>71 then
    begin d:=x+length(s)-71; s:=copy(s,1,4)+'...'+copy(s,8+d,30); end;
   end;
  cmprint(BkRama,TxtRama,posx+1,posy,r);
  cmprint(p,i,x,1,s);
 End;


                        {=== 㭮 ப⪨ ==}
if (pos('b',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=10) then
 Begin
  if (tdirs+tfiles-1)<=0 then m:=1 else m:=tdirs+tfiles-1;
  k:=((from+f-2)*(PanelHi-2))div(m);
  for a:=1 to PanelHi+1 do
   begin
    p:=bkRama; i:=txtRama;
    r:='';
    if focused then
     begin
      r:='';
      if a=1 then         begin p:=bkBP; i:=txtBP; r:=''; end;
      if a=PanelHi+1 then begin p:=bkBP; i:=txtBP; r:=''; end;
      if a=k+2 then begin p:=bkBP; i:=txtBP; r:=''; end;
     end;
    cmprint(p,i,posx+39,posy+a,r);
   end;
 End;


                    {==========  ᪮ =========}
if (pos('d',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=10) then
 Begin
  s:='';
  whatflopp(a,b);
  if a<>0 then s:=s+'A';
  if b<>0 then s:=s+'B';
  s:=s+getalldrivers;
  cmprint(bkDiskLineR,txtDiskLineR,posx,panellong,'[ ');
  d:=posx+3;
  for x:=1 to length(s) do
   begin
    p:=bkDiskLineNT; i:=txtDiskLineNT;
    if s[x]=pcnd[1] then begin p:=bkDiskLineST; i:=txtDiskLineST; end;
    cmprint(p,i,d,panellong,s[x]);
    p:=bkDiskLineNT; i:=txtDiskLineNT;
    inc(d);
    if length(s)<17 then begin cmprint(p,i,d,panellong,' '); inc(d); end;
   end;
  if d>40 then a:=d-40 else a:=d;
  cmprint(bkDiskLineR,txtDiskLineR,d-1,PanelLong,' ]');
  cmprint(bkRama,txtRama,d+1,PanelLong,fill(39-a,''));
  cmprint(bkRama,txtRama,posx+39,PanelLong,'');
 End;


                    {========== CURSOR NAME =========}
if (pos('n',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=10) then
 Begin
  Case PanelType of
   pcPanel:
      BEGIN
       m:=pcfrom+pcf-1; nm:=space(38);
       if (m>0)and(pctdirs+pctfiles>0) then
        if place=left then nm:=pcNameLine(lp,m) else nm:=pcNameLine(rp,m);
       m:=0; for n:=1 to pctdirs+pctfiles do if pcdir^[n].mark then inc(m);
       if (infolines<=1)and(m<>0) then else
       cmprint(bkCurLine,txtCurLine,posx+1,PutFrom+PanelHi+1,nm);{}
       cmPrint(bkRama,txtRama,posx,PutFrom+PanelHi+1,''); cmPrint(bkRama,txtRama,posx+39,PutFrom+PanelHi+1,'');
      END;
  End;
 End;


                       {=========== SELECTED =============}
if (pos('s',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=10) then
 Begin
  Case PanelType of
   pcPanel:
     BEGIN
      m:=0; byt:=0;
      for n:=1 to pctdirs+pctfiles do
       if pcdir^[n].mark then
       begin inc(m); if pcdir^[n].flength>=0 then inc(byt,pcdir^[n].flength); end;
      if lang=rus then stemp:='  ⬥祭' else stemp:='No files selected';
      if m>0 then if lang=rus
       then stemp:='~`'+changechar(extnum(strr(byt)),' ',',')+'~`  ⬥祭  ~`'+strr(m)+'~` 䠩'+ewfiles(m,lang)
       else stemp:='~`'+changechar(extnum(strr(byt)),' ',',')+'~` bytes selected in ~`'+strr(m)+'~` file'+ewfiles(m,lang);
      i:=19-(length(without(stemp,'~`'))div 2); if i<0 then i:=0;
      nm:=space(i)+stemp; nm:=nm+space(abs(38-CClen(nm)));
      if CClen(nm)>38 then delete(nm,39+8,10);
      x:=posx+1; if InfoLines<=1 then y:=PutFrom+PanelHi+1 else y:=PutFrom+PanelHi+2;
      if (m=0)and(infolines=1) then else
      StatusLineColor(bkSelectedNT,txtSelectedNT,bkSelectedST,txtSelectedST,x,y,nm);
        cmPrint(bkRama,txtRama,posx,y,''); cmPrint(bkRama,txtRama,posx+39,y,'');
     END;
  End;
 End;

                       {=========== FREE =============}
if (pos('f',strlo(parts))<>0)or(pos('A',parts)<>0) then if (PanelType>=1)and(PanelType<=10) then
 Begin
  Case PanelType of
   pcPanel:
     BEGIN
      if infolines>2 then
       begin
        byt:=diskfree(ord(pcnd[1])-64); nm:=extnum(strr(byt));
        if byt>999999999 then nm:=extnum(strr(byt div 1000000))+'G';
        stemp:=changechar(nm,' ',',');
        if lang=rus
          then nm:='~`'+stemp+'~`  ᢮  ᪥ ~`'
          else nm:='~`'+stemp+'~` bytes free on drive ~`';
        stemp:=nm+pcnd[1]+':~`';
        i:=19-(length(without(stemp,'~`'))div 2); if i<0 then i:=0;
        nm:=space(i)+stemp;
        nm:=nm+space(abs(38-CClen(nm))); if CClen(nm)>38 then delete(nm,39+8,10);
        x:=posx+1; if InfoLines<=1 then y:=PutFrom+PanelHi+1 else y:=PutFrom+PanelHi+2;
        StatusLineColor(bkFreeLineNT,txtFreeLineNT,bkFreeLineST,txtFreeLineST,x,y+1,nm);{}
        cmPrint(bkRama,txtRama,posx,y+1,''); cmPrint(bkRama,txtRama,posx+39,y+1,'');
       end;
     END;
  End;
 End;


if (pos('i',strlo(parts))<>0)or(pos('A',parts)<>0) then
 Begin
  Case lp.PanelType of
   pcPanel:  if rp.PanelType=infPanel then pcInfoPanel(left);
  End;
  Case rp.PanelType of
   pcPanel:  if lp.PanelType=infPanel then pcInfoPanel(right);
  End;
 End;

End;



{============================================================================}
Function  TPanel.GetTreeC(path:string):byte;
Begin
TreeC:=length(path)-length(without(path,'\'));
GetTreeC:=TreeC;
End;



{============================================================================}
Function  TPanel.Insed:word;
Var
   i,m:word;
Begin
m:=0;
Case PanelType of
 pcPanel:
   BEGIN
    for i:=1 to pctdirs+pctfiles do if pcDir^[i].mark then inc(m);
   END;
End;
Insed:=m;
End;



{============================================================================}
Procedure TPanel.Inside;
Begin
Case PanelType of
 pcPanel:
   BEGIN
     tdirs:=pctdirs;
     tfiles:=pctfiles;
     f:=pcf;
     from:=pcfrom;
   END;
End;
End;



{============================================================================}
Procedure TPanel.Outside;
Var PT:byte;
Begin
PT:=PanelType;
if PT=noPanel then PT:=LastPanelType;
if PT=infPanel then PT:=clLastPanelType;
Case PT of
 pcPanel:
   BEGIN
     pctdirs:=tdirs;
     pctfiles:=tfiles;
     pcf:=f;
     pcfrom:=from;
   END;
End;
End;



{============================================================================}
Function TPanel.Index:word;
Begin
 Index:=from+f-1;
End;





{============================================================================}
Function TPanel.TrueName(ind:word):string;
Var
    s:string;
Begin
  if nospace(pcDir^[ind].fext)=''
    then s:=pcDir^[ind].fname
    else s:=pcDir^[ind].fname+'.'+pcDir^[ind].fext;
  if ind>pctdirs then s:=strlo(s) else s:=strhi(s);
TrueName:=s;
End;







{============================================================================}
Procedure TPanel.TrueCur;
Var
    fnd:boolean; st:string; i:integer;
Begin
fnd:=false;
 Case panelType of

  pcPanel:
   BEGIN
    for i:=1 to pctdirs+pctfiles do
     begin
      if nospace(pcdir^[i].fext)=''
        then st:=strlo(pcdir^[i].fname)
        else st:=strlo(pcdir^[i].fname+'.'+pcdir^[i].fext);
      if nospaceLR(st)=nospaceLR(strlo(pcnn)) then begin fnd:=true; break; end;
     end;

    if fnd then
     begin
      pcf:=1; pcfrom:=1;
      while pcfrom+pcf-1<i do
       begin
        inc(pcf);
        if pcf>panelhi*columns then begin pcf:=panelhi*columns; inc(pcfrom); end;
       end;
     end;

    while pcfrom+pcf-1 > pctdirs+pctfiles do
     begin
      dec(pcfrom);
      if pcfrom<1 then begin pcfrom:=1; dec(pcf); end;
     end;
    if pcf<1 then pcf:=1;
   END;

 End;
End;



{============================================================================}
Procedure TPanel.Enter;
Var
    stemp:string; i:word; a,b,c:byte;
Begin
if command<>'' then begin HistoryCommand; DoExec(command,true); end;
Case PanelType of
 pcPanel:
   BEGIN

    if (pcDir^[Index].fext='BAT')or(pcDir^[Index].fext='COM')or(pcDir^[Index].fext='EXE')
    then
     Begin
      command:=TrueName(Index);
      DoExec(command,true);
     End;

    if Index<=tdirs then
     begin
      if NoSpace(pcnn)='..' then
       begin
        Dec(TreeC);
        stemp:=ReverseStr(pcnd);
        pcnn:=copy(ReverseStr(Copy(stemp,2,pos('\',Copy(stemp,2,15)))),2,15);
        stemp:=reversestr(pcnd);
        stemp:=reversestr(copy(stemp,2,pos('\',copy(stemp,2,15))-1));
        stemp:=copy(pcnd,1,length(pcnd)-length(stemp)-1);
        if stemp[length(stemp)]<>'\' then stemp:=stemp+'\';
        pcMDF(stemp);
        TrueCur;
       end
      else
       begin
        inc(treec); pcfrom:=1; pcf:=1;
        stemp:=pcnd+pcnn+'\';
        pcMDF(stemp);
       end;
      Inside;
      Info('csi');{}
      pcPDF(pcfrom);{}
     end
    else
     begin
      stemp:=whatbyext(pcnd+pcnn,'ExecuteByExtention');
      ExecuteView(reBuildName(stemp,pcnd+pcnn));

      stemp:=whatbylen(strr(pcDir^[Index].flength),pcnd+pcnn,'ExecuteByLength',true);
      ExecuteView(reBuildName(stemp,pcnd+pcnn));
     end;
   END;
End;
End;




{============================================================================}
Procedure TPanel.CtrlPgUp;
Var
    stemp:string; i:word;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if TreeC>1 then
     Begin
      Dec(TreeC);
      stemp:=ReverseStr(pcnd);
      pcnn:=copy(ReverseStr(Copy(stemp,2,pos('\',Copy(stemp,2,15)))),2,15);
      stemp:=reversestr(pcnd);
      stemp:=reversestr(copy(stemp,2,pos('\',copy(stemp,2,15))-1));
      stemp:=copy(pcnd,1,length(pcnd)-length(stemp)-1);
      if stemp[length(stemp)]<>'\' then stemp:=stemp+'\';
      pcMDF(stemp);
      TrueCur;
      Inside;
      Info('csi');
      pcPDF(pcfrom);{}
     End;
   END;
End;
End;




{============================================================================}
Procedure TPanel.CtrlPgDn;
Var
    stemp:string;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if Index<=tdirs then
     begin
      if NoSpace(pcnn)='..' then
       begin
        Dec(TreeC);
        stemp:=ReverseStr(pcnd);
        pcnn:=copy(ReverseStr(Copy(stemp,2,pos('\',Copy(stemp,2,15)))),2,15);
        stemp:=reversestr(pcnd);
        stemp:=reversestr(copy(stemp,2,pos('\',copy(stemp,2,15))-1));
        stemp:=copy(pcnd,1,length(pcnd)-length(stemp)-1);
        if stemp[length(stemp)]<>'\' then stemp:=stemp+'\';
        pcMDF(stemp);
        TrueCur;
       end
      else
       begin
        inc(treec); pcfrom:=1; pcf:=1;
        pcnd:=pcnd+pcnn+'\';
        pcMDF(pcnd);
       end;
     end;
    Inside;
    Info('csi');
    pcPDF(pcfrom);{}
   END;
End;
End;




{============================================================================}
Procedure TPanel.AltF1F2(ps:byte);
Var
     t:word; stemp:string;
Label fin;
Begin
 CurOff; CancelSB;
 w_twosided:=false;
 stemp:=snChooseDrive(ps);
 w_twosided:=true;
 if stemp<>'0' then
  begin
   if CheckDrv(stemp[1])=0 then
     begin
      Case ps of
       Left:
         BEGIN
          if lp.PanelType<>pcPanel then
           Begin
            lp.PanelType:=pcPanel;
            lp.Build('012');
           End;
          {$I-} ChDir(stemp+':'); {$I+}
          if ioresult<>0 then
           begin
            if lang=rus
              then errormessage('ன⢮ '+stemp+':  ⮢')
              else errormessage('Drive '+stemp+': not ready');
           end
          else
           begin
            lp.pcnd:=curentdir;
            if lp.pcnd[length(lp.pcnd)]<>'\' then lp.pcnd:=lp.pcnd+'\';
            lp.pcf:=1; lp.pcfrom:=1; lp.TreeC:=1;
            for t:=1 to MaxFiles do begin lp.pcdir^[t].mark:=false; end;
            lp.pcMDF(lp.pcnd);
            lp.Inside;
            lp.Info('cbdnsfi');
            lp.pcPDF(lp.pcfrom);
           end;
         END;
       Right:
         BEGIN
          if rp.PanelType<>pcPanel then
           begin
            rp.PanelType:=pcPanel;
            rp.Build('012');
           end;
          {$I-} ChDir(stemp+':'); {$I+}
          if ioresult<>0 then
           begin
            if lang=rus
              then errormessage('ன⢮ '+stemp+':  ⮢')
              else errormessage('Drive '+stemp+': not ready');
           end
          else
           begin
            rp.pcnd:=curentdir;
            if rp.pcnd[length(rp.pcnd)]<>'\' then rp.pcnd:=rp.pcnd+'\';
            rp.pcf:=1; rp.pcfrom:=1; rp.TreeC:=1;
            for t:=1 to MaxFiles do begin rp.pcdir^[t].mark:=false; end;
            rp.pcMDF(rp.pcnd);
            rp.Inside;
            rp.Info('cbdnsfi');
            rp.pcPDF(rp.pcfrom);
           end;
         END;
      End;
     end
    else
     begin
            if lang=rus
              then errormessage('ன⢮ '+stemp+':  ⮢')
              else errormessage('Drive '+stemp+': not ready');
     end;
  end;
fin:
End;



{============================================================================}
Procedure TPanel.CtrlLeftRightDoIt(stemp:char);
Var
    btemp:byte; t:word;
begin
  {$I-} ChDir(stemp+':'); {$I+}
  if ioresult<>0 then
   begin
    if lang=rus
      then errormessage('ன⢮ '+stemp+':  ⮢')
      else errormessage('Drive '+stemp+': not ready');
   end
  else
   begin
    pcnd:=curentdir;
    if pcnd[length(pcnd)]<>'\' then pcnd:=pcnd+'\';
    pcf:=1; pcfrom:=1; TreeC:=1;
    for t:=1 to MaxFiles do begin pcdir^[t].mark:=false; end;
    pcMDF(pcnd);
    Inside;
    Info('cbdnsfi');
    pcPDF(pcfrom);
   end;
end;



{============================================================================}
Procedure TPanel.CtrlLeft;
Var
    stemp:string[27]; btemp:byte; t:word;
Begin
if (paneltype=pcPanel) then
 begin
  stemp:=getalldrivers;
  for btemp:=1 to length(stemp) do if stemp[btemp]=pcnd[1] then break;
  dec(btemp); if btemp<1 then btemp:=length(stemp);
  CtrlLeftRightDoIt(stemp[btemp]);
 end;
End;



{============================================================================}
Procedure TPanel.CtrlRight;
Var
    stemp:string[27]; btemp:byte; t:word;
Begin
if (paneltype=pcPanel) then
 begin
  stemp:=getalldrivers;
  for btemp:=1 to length(stemp) do if stemp[btemp]=pcnd[1] then break;
  inc(btemp); if btemp>length(stemp) then btemp:=1;
  CtrlLeftRightDoIt(stemp[btemp]);
 end;
End;



{============================================================================}
Procedure TPanel.Insert;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if pcDir^[Index].fname<>' ..' then pcDir^[Index].mark:=not pcDir^[Index].mark;
    inc(f);
   END;

End;
Info('si')
End;




{============================================================================}
Procedure TPanel.Star(ctrled:boolean);
Var
    b,i:word;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if Ctrled then b:=1 else b:=pctdirs+1;
    for i:=b to pctdirs+pctfiles do if pcDir^[i].fname<>' ..' then pcDir^[i].mark:=not pcDir^[i].mark;
   END;
End;
Info('si');
End;





{============================================================================}
Procedure TPanel.Plus(ctrled:boolean);
Var
    a,b,i:word; s,stemp:string[12];
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if Ctrled then
     begin a:=1; b:=pctdirs; s:='*.*'; end
    else
     begin
      a:=pctdirs+1; b:=pctdirs+pctfiles;
      if lang=rus then stemp:=' 롮p ' else stemp:=' Select ';
      plusmask:=nospace(GetWildMask(stemp,plusmask));
      if scanf_esc then exit;
      s:=plusmask;
     end;
    for i:=a to b do if pcDir^[i].fname<>' ..' then
     Begin
      if nospace(pcdir^[i].fext)=''
        then stemp:=nospace(pcdir^[i].fname+'.!!!')
        else stemp:=nospace(pcdir^[i].fname+'.'+pcdir^[i].fext);
      if wild(stemp,s,true) then pcDir^[i].mark:=true;
     End;
   END;
End;
Info('si');
End;





{============================================================================}
Procedure TPanel.Minus(ctrled:boolean);
Var
    a,b,i:word; s,stemp:string[12];
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if Ctrled then
     begin a:=1; b:=pctdirs; s:='*.*'; end
    else
     begin
      a:=pctdirs+1; b:=pctdirs+pctfiles;
      if lang=rus then stemp:=' ⬥ ' else stemp:=' Cancel ';
      minusmask:=nospace(GetWildMask(stemp,minusmask));
      if scanf_esc then exit;
      s:=plusmask;
     end;
    for i:=a to b do if pcDir^[i].fname<>' ..' then
     Begin
      if nospace(pcdir^[i].fext)=''
        then stemp:=nospace(pcdir^[i].fname+'.!!!')
        else stemp:=nospace(pcdir^[i].fname+'.'+pcdir^[i].fext);
      if wild(stemp,minusmask,true) then pcDir^[i].mark:=false;
     End;
   END;
End;
Info('si');
End;





{============================================================================}
Function TPanel.FirstMarked:word;
Var
    i:word; fnd:boolean;
Begin
fnd:=false;
Case PanelType of
 pcPanel:
   BEGIN
    for i:=1 to pctdirs+pctfiles do if pcDir^[i].mark then begin fnd:=true; break; end;
   END;
End;
if fnd then FirstMarked:=i else FirstMarked:=0;
End;






{============================================================================}
Procedure TPanel.Del;
Begin
if PanelType=pcPanel then pcF8;
End;



{============================================================================}
Procedure TPanel.fCopy;
Var
    i:word; n,s:string; was:longint;
Begin
if (PanelTypeOf(Focus)=pcPanel)and(PanelTypeOf(oFocus)=pcPanel)
 then pc2pc(_F5);
End;



{============================================================================}
Procedure TPanel.fMove;
Var
    i:word; n,s:string;
    skip:boolean;
    TargetPath:string;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    Case PanelTypeOf(oFocus) of
     pcPanel: pc2pc(_F6);
    End;
   END;
End;
End;





{============================================================================}
Procedure TPanel.Rename;
Var
    i:word; n,s:string;
    skip:boolean;
    TargetPath:string;
Begin
Case PanelType of
 pcPanel: pcRename;
End;
End;





{============================================================================}
Function TPanel.View(sys:boolean):longint;
Var
    i:word; total,size:longint; UserOut:boolean; path:string;
Begin
UserOut:=false; total:=0;
if PanelType=pcPanel then
 BEGIN
  if not sys then
   begin
    if Index>TDirs then
     begin
      {
      if InternalView then
       begin
        intView(pcnd+TrueName(Index));
        GlobalReDraw;
       end
       else
      {}
      pcViewFile(pcnd+TrueName(Index));{}
      Exit;
     end;
   end;

  if Insed=0 then
   begin
    path:=TrueName(Index);
    if nospace(path)='..' then path:=pcnd else path:=pcnd+path;
    if DirSize(path,pcDir^[Index].priory,size,UserOut,sys) then
      if sys then inc(total,size) else pcDir^[Index].flength:=size;
   end;
  for i:=1 to pctdirs+pctfiles do if pcDir^[i].mark then
   begin
    if sys then if UserOut then break;
      if DirSize(pcnd+TrueName(i),pcDir^[i].priory,size,UserOut,sys) then
      if sys then inc(total,size) else pcDir^[i].flength:=size;
   end;
  View:=total;
  reInfo('s');
 END;
End;




{============================================================================}
Procedure TPanel.Edit;
Begin
Case PanelType of
 pcPanel:
   BEGIN
    if Index>TDirs then
     begin
      pcEditFile(pcnd+TrueName(Index));
      Exit;
     end;
   END;
End;
End;




{============================================================================}
Procedure TPanel.FileAttrs;
Var
    kb:word;
    n:byte;
Begin
Case PanelType of
 pcPanel: pcAltF;
End;
End;




{============================================================================}
Procedure TPanel.AltNumber(n:byte);
Var
    stemp:string;
Begin
getprofile(startdir+'\sn.ini','FastCatalog','Alt'+strr(n-119),stemp);
if nospace(stemp)<>'' then
 begin
  PanelType:=pcPanel;
  pcnd:=stemp;
  pcfrom:=1; pcf:=1;
  pcMDF(pcnd);
  Inside;
  Info('cdsfi');
  pcPDF(pcfrom);
 end;
End;



{============================================================================}
Procedure TPanel.pcJoinFiles;
type tbuf=array[1..2] of byte;
var
    i,c:word;
    s:string;
    fs,fd:file;
    buf:^tbuf;
    nw,nr:word;
begin
c:=0; for i:=pctdirs+1 to pctdirs+pctfiles do if pcdir^[i].mark then inc(c);
if c<2 then exit;
for i:=1 to pctdirs do if pcdir^[i].mark then pcdir^[i].mark:=false;
pcPDF(pcfrom); reInfo('s');

 CancelSB;
 colour(bkdRama,txtdRama);
 scputwin(bkdRama,txtdRama,24,halfmaxy-3,57,halfmaxy+2);
 if lang=rus then cmcentre(bkdRama,txtdRama,halfmaxy-3,' C 䠩')
 else cmcentre(bkdRama,txtdRama,halfmaxy-3,' Join files ');

 if lang=rus then s:='C ~`'+strr(c)+'~` 䠩'+efiles(c,rus)+'  䠩'
             else s:='Join ~`'+strr(c)+'~` file'+efiles(c,lang)+' to file';
 StatusLineColor(bkdLabelST,txtdLabelST,bkdLabelNT,txtdLabelNT,41-(length(without(s,'~`'))div 2),halfmaxy-1,s);

 printself(bkdInputNT,txtdInputNT,35,halfmaxy+0,12);
 colour(bkdInputNT,txtdInputNT);
 curon;
 s:=scanf(35,halfmaxy+0,'',12,12,1);
 curoff;
 restscr;
 putcmdline;
 if scanf_esc then exit;

 if nospace(s)<>'' then
  begin
   s:=getof(s,_name)+getof(s,_ext);
   getmem(buf,32768);
   {$I-}
   assign(fd,pcnd+s); rewrite(fd,1);
   for i:=pctdirs+1 to pctdirs+pctfiles do if pcdir^[i].mark then
    begin
     s:=pcnd+TrueName(i);
     assign(fs,s); reset(fs,1);
     repeat
      blockread(fs,buf^,32768,nr);
      blockwrite(fd,buf^,nr,nw);
     until (NR=0)or(NW<>NR);
     close(fs);
     pcdir^[i].mark:=false;
    end;
   freemem(buf,32768);
   close(fd);
   {$I+}
   if ioresult<>0 then;
  end;
reMDF;
reTrueCur;
reInside;
rePDF;
reInfo('cbdnsfi');
end;







{============================================================================}
Procedure TPanel.Navigate;
Var
    kk,kb:word; k:char; n:byte; stemp:string[20];
Label LOOP, Cont;
Begin
reInfo('cbdnsfi');
rePDF;
LOOP:

Inside;
cStatusBar(bkSBarNT,txtSBarNT,bkSBarST,txtSBarST,0,sBar[lang,PanelType]);
PutCmdLine;
if Moused then MouseOn; {showcur;{}

Cont:
kb:=KeyCode;

case kb of

 _Tab:    begin snKernelExitCode:=9; Exit; end;
 _CtrlEnd:begin snKernelExitCode:=9; Exit; end;

 _AltX:   snDone;
 _Esc:    EscPressed;

 _AltF9:  Setup;

 _CtrlE:  begin
           dec(HistoryIndex);
           if HistoryIndex<1 then HistoryIndex:=HistoryTotal;
           command:=nospaceLR(History[HistoryIndex]);
          end;
 _CtrlX:  begin
           inc(HistoryIndex);
           if HistoryIndex>HistoryTotal then HistoryIndex:=HistoryTotal;
           command:=nospaceLR(History[HistoryIndex]);
          end;

 _CtrlK:  if place=left then CtrlKPressed(lp) else CtrlKPressed(rp);
 _CtrlB:  begin CtrlBPressed(length(pcnd),gmaxy-15); Inc(CommandXPos); end;
 _CtrlJ:  pcJoinFiles;
 _AltPlus:  AltPlusPressed;
 _Alt1,_Alt2,_Alt3,_Alt4,_Alt5,_Alt6,_Alt7,_Alt8,_Alt9,_Alt0: AltNumber(hi(kb));

 _AltF:   FileAttrs;

 _AltM:   errormessage('Free avail memory: '+strr(memavail));

 _F1:     About;

 _AltF1:  AltF1F2(left);
 _AltF2:  AltF1F2(right);
 _CtrlHome: AltF1F2(focus);
 _CtrlLeft: CtrlLeft;
 _CtrlRight:CtrlRight;
 _CtrlBkSlash:
          Begin
           if PanelType=pcPanel then
            BEGIN
             if TreeC>1 then pcnn:=copy(pcnd,4,pos('\',copy(pcnd,4,255))-1);
             pcnd:=copy(pcnd,1,3); reMDF;
             TrueCur; Inside; reInfo('cdsfi');
            END;
          End;

 _Ins:    Insert;{}
  Pad0:   Insert;{}
  PadStar:Star(false);
  PadPlus:Plus(false);
  PadMinus:Minus(false);
  CtrlPadStar:Star(true);
  CtrlPadPlus:Plus(true);
  CtrlPadMinus:Minus(true);

 _CtrlBkSp:  if bkspupdir then CtrlPgUp;
 _BkSp    :  if bkspupdir then if nospace(command)='' then CtrlPgUp;


 _CtrlF3: Begin SortType:=NameType; GlobalSort(255); TrueCur; Inside; rePDF; End;
 _CtrlF4: Begin SortType:=ExtType; GlobalSort(255); TrueCur; Inside; rePDF; End;
 _CtrlF5: Begin SortType:=LenType; GlobalSort(255); TrueCur; Inside; rePDF; End;
 _CtrlF6: Begin SortType:=NonType; reMDF; GlobalSort(255); TrueCur; Inside; rePDF; End;

 _AltF10: AltF10Pressed;
 _CtrlF10:CtrlF10Pressed;
 _CtrlF1: begin CtrlF1Pressed; Exit; end;
 _CtrlF2: begin CtrlF2Pressed; Exit; end;
 _CtrlP:  begin Case focus of Left:CtrlF2Pressed; Right:CtrlF1Pressed; End; {Exit;{} end;
 _CtrlO:  begin CtrlF1Pressed; CtrlF2Pressed; end;


 _CtrlL:  begin CtrlLPressed; end;

 _CtrlR:  begin
           reMDF; reInfo('cdnsfi');
           reTrueCur;
           reInside;
           rePDF;
          end;

 _F3:     View(false);
 _AltF3:  Begin AltF3Pressed:=true; View(false); AltF3Pressed:=false; End;
 _F4:     Edit;
 _F5:     Begin AltF5Pressed:=false; fCopy; End;
 _AltF5:  Begin AltF5Pressed:=true; fCopy; AltF5Pressed:=false; End;
 _F6:     fMove;
 _AltF6:  Rename;
 _F7:     Begin
           Case PanelType of
            pcPanel: begin pcF7Pressed(pcnd,posx); end;
           End;
          End;

 _F8:     Del;
 _AltF8:  ViewHistoryCommands;
 _Del:    begin
           if length(nospace(Command))>0 then
            begin
             Command:=copy(Command,1,(CommandXFrom+CommandXPos-1)-1)+
                      copy(Command,(CommandXFrom+CommandXPos-1)+1,255);
            end
           else if Del_F8 then Del;
          end;


 _Up:
          Begin
           {HideCur;{}
           dec(f);
          End;
 _Down:
          Begin
           {HideCur;{}
           inc(f);
          End;
 _Left:
          Begin
           {HideCur;{}
           if LShift or RShift then Dec(CommandXPos) else dec(f,PanelHi);
          End;
 _Right:
          Begin
           {HideCur;{}
           if LShift or RShift then Inc(CommandXPos) else inc(f,PanelHi);
          End;
  _PgUp:
          Begin
           {HideCur;{}
           dec(f,PanelHi*Columns-1);
          End;
  _PgDn:
          Begin
           {HideCur;{}
           inc(f,PanelHi*Columns-1);
          End;
  _Home:
          Begin
           {HideCur;{}
           if LShift or RShift then begin CommandXFrom:=1; CommandXPos:=1; end else
            begin
             from:=1; f:=1;
            end;
          End;
  _End:
          Begin
           {HideCur;{}
           if LShift or RShift then begin CommandXFrom:=255; CommandXPos:=255; end else
            begin
             from:=tdirs+tfiles-Columns*PanelHi+1;
             f:=Columns*PanelHi;
            end;
          End;

  _Enter: Enter;
  _CtrlPgUp: CtrlPgUp;
  _CtrlPgDn: CtrlPgDn;

  _CtrlV:
          Begin
           case Columns of 2:Columns:=3; 3:Columns:=2; end;
           Build('12'); TrueCur; Inside; pcPDF(from);
          End;
  _Space: if nospace(Command)='' then Begin Insert; kb:=0; End;
  _CtrlEnter:
          Begin
           if PanelType=pcPanel then
            BEGIN
             if nospace(TrueName(Index))<>'..' then
             if (command[length(command)]<>'\')and(command[length(command)]<>' ')and(nospace(command)<>'')
               then command:=command+' '+TrueName(Index)+' '
               else command:=command+TrueName(Index)+' ';
             CommandXFrom:=255; CommandXPos:=255;
            END;
          End;
  _CtrlOpScob:
          Begin
           if (command[length(command)]<>' ')and(nospace(command)<>'')
             then command:=command+' '+lp.pcnd
             else command:=command+lp.pcnd;
           CommandXFrom:=255; CommandXPos:=255;
          End;
  _CtrlClScob:
          Begin
           if (command[length(command)]<>' ')and(nospace(command)<>'')
             then command:=command+' '+rp.pcnd
             else command:=command+rp.pcnd;
           CommandXFrom:=255; CommandXPos:=255;
          End;
end;

if (chr(lo(kb)) in [#32..''])and
   (hi(kb) in [0..$d,$10..$1b,$1e..$29,$2b..$35,$39]) then
 begin
  Command:=copy(Command,1,(CommandXFrom+CommandXPos-1)-1)+chr(lo(kb))+
           copy(Command,(CommandXFrom+CommandXPos-1),255);
  Inc(CommandXPos);
  PutCmdLine;
 end;
if chr(lo(kb)) in [#8] then
 begin
  Command:=copy(Command,1,(CommandXFrom+CommandXPos-1)-2)+
           copy(Command,(CommandXFrom+CommandXPos-1),255);
  Dec(CommandXPos);
  PutCmdLine;
 end;

if tdirs+tfiles>Columns*PanelHi then n:=Columns*PanelHi else n:=tdirs+tfiles;
if f>n then begin inc(from,f-n); f:=n; end;
if f<1 then begin dec(from,1-f); f:=1; end;
if from>tdirs+tfiles-Columns*PanelHi+1 then from:=tdirs+tfiles-Columns*PanelHi+1;
if from<1 then from:=1;

Outside;
Info('bn');
PDF;

if Moused then MouseOff;{}
GoTo LOOP;
End;





Begin
lp.posx:=1; rp.posx:=41;
lp.posy:=1; rp.posy:=1;

lp.Columns:=3; rp.Columns:=3;
lp.InfoLines:=3; rp.InfoLines:=3;

lp.NameLine:=true; rp.NameLine:=true;

lp.PanelType:=pcPanel; rp.PanelType:=pcPanel;
lp.SortType:=extType; rp.SortType:=extType;

lp.focused:=false;
rp.focused:=false;

lp.f:=1; lp.from:=1;
rp.f:=1; rp.from:=1;

lp.Place:=left;
rp.Place:=right;
End.